"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function getContractNode(contract) {
    return (contract.ast || { nodes: [] }).nodes.find((contractNode) => contractNode.nodeType === "ContractDefinition"
        && (contractNode.name === contract.contractName
            || contractNode.name === contract.contract_name));
}
exports.getContractNode = getContractNode;
function getDeclarationsForTypes(contracts, types) {
    let result = {};
    for (let contract of contracts) {
        if (contract) {
            for (const node of contract.nodes) {
                if (types.includes(node.nodeType)) {
                    result[node.id] = node;
                }
            }
        }
    }
    return result;
}
function getEventDefinitions(contracts) {
    const types = [
        "EventDefinition"
    ];
    return getDeclarationsForTypes(contracts, types);
}
exports.getEventDefinitions = getEventDefinitions;
//# sourceMappingURL=utils.js.map